<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (36)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="object-to-primitive-conversion">Object to primitive conversion</h1>
    <p>
      What happens when objects are added <code>obj1 + obj2</code>, subtracted
      <code>obj1 - obj2</code> or printed using <code>alert(obj)</code>?
    </p>
    <p>
      In that case, objects are auto-converted to primitives, and then the
      operation is carried out.
    </p>
    <p>
      In the chapter
      <a href="info:type-conversions" class="uri">info:type-conversions</a>
      we’ve seen the rules for numeric, string and boolean conversions of
      primitives. But we left a gap for objects. Now, as we know about methods
      and symbols it becomes possible to fill it.
    </p>
    <ol type="1">
      <li>
        All objects are <code>true</code> in a boolean context. There are only
        numeric and string conversions.
      </li>
      <li>
        The numeric conversion happens when we subtract objects or apply
        mathematical functions. For instance, <code>Date</code> objects (to be
        covered in the chapter <a href="info:date" class="uri">info:date</a>)
        can be subtracted, and the result of <code>date1 - date2</code> is the
        time difference between two dates.
      </li>
      <li>
        As for the string conversion – it usually happens when we output an
        object like <code>alert(obj)</code> and in similar contexts.
      </li>
    </ol>
    <h2 id="toprimitive">ToPrimitive</h2>
    <p>
      We can fine-tune string and numeric conversion, using special object
      methods.
    </p>
    <p>
      There are three variants of type conversion, so-called “hints”, described
      in the
      <a href="https://tc39.github.io/ecma262/#sec-toprimitive">specification</a
      >:
    </p>
    <dl>
      <dt><code>"string"</code></dt>
      <dd>
        <p>
          For an object-to-string conversion, when we’re doing an operation on
          an object that expects a string, like <code>alert</code>:
        </p>
        <div class="sourceCode" id="cb1">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="co">// output</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="at">alert</span>(obj)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="co">// using object as a property key</span></a>
<a class="sourceLine" id="cb1-5" title="5">anotherObj[obj] <span class="op">=</span> <span class="dv">123</span><span class="op">;</span></a></code></pre>
        </div>
      </dd>
      <dt><code>"number"</code></dt>
      <dd>
        <p>For an object-to-number conversion, like when we’re doing maths:</p>
        <div class="sourceCode" id="cb2">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="co">// explicit conversion</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="kw">let</span> num <span class="op">=</span> <span class="at">Number</span>(obj)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="co">// maths (except binary plus)</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="kw">let</span> n <span class="op">=</span> <span class="op">+</span>obj<span class="op">;</span> <span class="co">// unary plus</span></a>
<a class="sourceLine" id="cb2-6" title="6"><span class="kw">let</span> delta <span class="op">=</span> date1 <span class="op">-</span> date2<span class="op">;</span></a>
<a class="sourceLine" id="cb2-7" title="7"></a>
<a class="sourceLine" id="cb2-8" title="8"><span class="co">// less/greater comparison</span></a>
<a class="sourceLine" id="cb2-9" title="9"><span class="kw">let</span> greater <span class="op">=</span> user1 <span class="op">&gt;</span> user2<span class="op">;</span></a></code></pre>
        </div>
      </dd>
      <dt><code>"default"</code></dt>
      <dd>
        <p>
          Occurs in rare cases when the operator is “not sure” what type to
          expect.
        </p>
        <p>
          For instance, binary plus <code>+</code> can work both with strings
          (concatenates them) and numbers (adds them), so both strings and
          numbers would do. So if a binary plus gets an object as an argument,
          it uses the <code>"default"</code> hint to convert it.
        </p>
        <p>
          Also, if an object is compared using <code>==</code> with a string,
          number or a symbol, it’s also unclear which conversion should be done,
          so the <code>"default"</code> hint is used.
        </p>
        <div class="sourceCode" id="cb3">
          <pre
            class="sourceCode js"
          ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="co">// binary plus uses the &quot;default&quot; hint</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="kw">let</span> total <span class="op">=</span> obj1 <span class="op">+</span> obj2<span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3"></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="co">// obj == number uses the &quot;default&quot; hint</span></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="cf">if</span> (user <span class="op">==</span> <span class="dv">1</span>) <span class="op">{</span> ... <span class="op">};</span></a></code></pre>
        </div>
        <p>
          The greater and less comparison operators, such as <code>&lt;</code>
          <code>&gt;</code>, can work with both strings and numbers too. Still,
          they use the <code>"number"</code> hint, not <code>"default"</code>.
          That’s for historical reasons.
        </p>
        <p>
          In practice though, we don’t need to remember these peculiar details,
          because all built-in objects except for one case (<code>Date</code>
          object, we’ll learn it later) implement
          <code>"default"</code> conversion the same way as
          <code>"number"</code>. And we can do the same.
        </p>
      </dd>
    </dl>
    <p>
      ``<code>smart header="No</code>"boolean"` hint" Please note – there are
      only three hints. It’s that simple.
    </p>
    <p>
      There is no “boolean” hint (all objects are <code>true</code> in boolean
      context) or anything else. And if we treat <code>"default"</code> and
      <code>"number"</code> the same, like most built-ins do, then there are
      only two conversions.
    </p>
    <pre><code>
**To do the conversion, JavaScript tries to find and call three object methods:**

1. Call `obj[Symbol.toPrimitive](hint)` - the method with the symbolic key `Symbol.toPrimitive` (system symbol), if such method exists,
2. Otherwise if hint is `&quot;string&quot;`
    - try `obj.toString()` and `obj.valueOf()`, whatever exists.
3. Otherwise if hint is `&quot;number&quot;` or `&quot;default&quot;`
    - try `obj.valueOf()` and `obj.toString()`, whatever exists.

## Symbol.toPrimitive

Let&#39;s start from the first method. There&#39;s a built-in symbol named `Symbol.toPrimitive` that should be used to name the conversion method, like this:

```js
obj[Symbol.toPrimitive] = function(hint) {
  // must return a primitive value
  // hint = one of &quot;string&quot;, &quot;number&quot;, &quot;default&quot;
};</code></pre>
    <p>For instance, here <code>user</code> object implements it:</p>
    <p>```js run let user = { name: “John”, money: 1000,</p>
    <p>
      <a href="hint">Symbol.toPrimitive</a> { alert(<code>hint: ${hint}</code>);
      return hint == “string” ? <code>{name: "${this.name}"}</code> :
      this.money; }, };
    </p>
    <p>
      // conversions demo: alert(user); // hint: string -&gt; {name: “John”}
      alert(+user); // hint: number -&gt; 1000 alert(user + 500); // hint:
      default -&gt; 1500 ```
    </p>
    <p>
      As we can see from the code, <code>user</code> becomes a self-descriptive
      string or a money amount depending on the conversion. The single method
      <code>user[Symbol.toPrimitive]</code> handles all conversion cases.
    </p>
    <h2 id="tostringvalueof">toString/valueOf</h2>
    <p>
      Methods <code>toString</code> and <code>valueOf</code> come from ancient
      times. They are not symbols (symbols did not exist that long ago), but
      rather “regular” string-named methods. They provide an alternative
      “old-style” way to implement the conversion.
    </p>
    <p>
      If there’s no <code>Symbol.toPrimitive</code> then JavaScript tries to
      find them and try in the order:
    </p>
    <ul>
      <li><code>toString -&gt; valueOf</code> for “string” hint.</li>
      <li><code>valueOf -&gt; toString</code> otherwise.</li>
    </ul>
    <p>
      These methods must return a primitive value. If <code>toString</code> or
      <code>valueOf</code> returns an object, then it’s ignored (same as if
      there were no method).
    </p>
    <p>
      By default, a plain object has following <code>toString</code> and
      <code>valueOf</code> methods:
    </p>
    <ul>
      <li>
        The <code>toString</code> method returns a string
        <code>"[object Object]"</code>.
      </li>
      <li>The <code>valueOf</code> method returns the object itself.</li>
    </ul>
    <p>Here’s the demo:</p>
    <p>```js run let user = { name: “John” };</p>
    <p>
      alert(user); // [object Object] alert(user.valueOf() === user); // true
      ```
    </p>
    <p>
      So if we try to use an object as a string, like in an
      <code>alert</code> or so, then by default we see
      <code>[object Object]</code>.
    </p>
    <p>
      And the default <code>valueOf</code> is mentioned here only for the sake
      of completeness, to avoid any confusion. As you can see, it returns the
      object itself, and so is ignored. Don’t ask me why, that’s for historical
      reasons. So we can assume it doesn’t exist.
    </p>
    <p>Let’s implement these methods.</p>
    <p>
      For instance, here <code>user</code> does the same as above using a
      combination of <code>toString</code> and <code>valueOf</code> instead of
      <code>Symbol.toPrimitive</code>:
    </p>
    <p>```js run let user = { name: “John”, money: 1000,</p>
    <p>
      // for hint=“string” toString() { return
      <code>{name: "${this.name}"}</code>; },
    </p>
    <p>
      // for hint=“number” or “default” valueOf() { return this.money; }, };
    </p>
    <p>
      alert(user); // toString -&gt; {name: “John”} alert(+user); // valueOf
      -&gt; 1000 alert(user + 500); // valueOf -&gt; 1500 ```
    </p>
    <p>
      As we can see, the behavior is the same as the previous example with
      <code>Symbol.toPrimitive</code>.
    </p>
    <p>
      Often we want a single “catch-all” place to handle all primitive
      conversions. In this case, we can implement <code>toString</code> only,
      like this:
    </p>
    <p>```js run let user = { name: “John”,</p>
    <p>toString() { return this.name; }, };</p>
    <p>
      alert(user); // toString -&gt; John alert(user + 500); // toString -&gt;
      John500 ```
    </p>
    <p>
      In the absence of <code>Symbol.toPrimitive</code> and
      <code>valueOf</code>, <code>toString</code> will handle all primitive
      conversions.
    </p>
    <h2 id="return-types">Return types</h2>
    <p>
      The important thing to know about all primitive-conversion methods is that
      they do not necessarily return the “hinted” primitive.
    </p>
    <p>
      There is no control whether <code>toString</code> returns exactly a
      string, or whether <code>Symbol.toPrimitive</code> method returns a number
      for a hint <code>"number"</code>.
    </p>
    <p>
      The only mandatory thing: these methods must return a primitive, not an
      object.
    </p>
    <p>
      ``<code>smart header="Historical notes" For historical reasons, if</code
      >toString<code>or</code>valueOf` returns an object, there’s no error, but
      such value is ignored (like if the method didn’t exist). That’s because in
      ancient times there was no good “error” concept in JavaScript.
    </p>
    <p>
      In contrast, <code>Symbol.toPrimitive</code> <em>must</em> return a
      primitive, otherwise there will be an error. ```
    </p>
    <h2 id="further-conversions">Further conversions</h2>
    <p>
      As we know already, many operators and functions perform type conversions,
      e.g. multiplication <code>*</code> converts operands to numbers.
    </p>
    <p>If we pass an object as an argument, then there are two stages:</p>
    <ol type="1">
      <li>
        The object is converted to a primitive (using the rules described
        above).
      </li>
      <li>
        If the resulting primitive isn’t of the right type, it’s converted.
      </li>
    </ol>
    <p>For instance:</p>
    <p>
      ```js run let obj = { // toString handles all conversions in the absence
      of other methods toString() { return “2”; }, };
    </p>
    <p>
      alert(obj * 2); // 4, object converted to primitive “2”, then
      multiplication made it a number ```
    </p>
    <ol type="1">
      <li>
        The multiplication <code>obj * 2</code> first converts the object to
        primitive (that’s a string <code>"2"</code>).
      </li>
      <li>
        Then <code>"2" * 2</code> becomes <code>2 * 2</code> (the string is
        converted to number).
      </li>
    </ol>
    <p>
      Binary plus will concatenate strings in the same situation, as it gladly
      accepts a string:
    </p>
    <p>```js run let obj = { toString() { return “2”; }, };</p>
    <p>
      alert(obj + 2); // 22 (“2” + 2), conversion to primitive returned a string
      =&gt; concatenation ```
    </p>
    <h2 id="summary">Summary</h2>
    <p>
      The object-to-primitive conversion is called automatically by many
      built-in functions and operators that expect a primitive as a value.
    </p>
    <p>There are 3 types (hints) of it:</p>
    <ul>
      <li>
        <code>"string"</code> (for <code>alert</code> and other operations that
        need a string)
      </li>
      <li><code>"number"</code> (for maths)</li>
      <li><code>"default"</code> (few operators)</li>
    </ul>
    <p>
      The specification describes explicitly which operator uses which hint.
      There are very few operators that “don’t know what to expect” and use the
      <code>"default"</code> hint. Usually for built-in objects
      <code>"default"</code> hint is handled the same way as
      <code>"number"</code>, so in practice the last two are often merged
      together.
    </p>
    <p>The conversion algorithm is:</p>
    <ol type="1">
      <li>
        Call <code>obj[Symbol.toPrimitive](hint)</code> if the method exists,
      </li>
      <li>
        Otherwise if hint is <code>"string"</code>
        <ul>
          <li>
            try <code>obj.toString()</code> and <code>obj.valueOf()</code>,
            whatever exists.
          </li>
        </ul>
      </li>
      <li>
        Otherwise if hint is <code>"number"</code> or <code>"default"</code>
        <ul>
          <li>
            try <code>obj.valueOf()</code> and <code>obj.toString()</code>,
            whatever exists.
          </li>
        </ul>
      </li>
    </ol>
    <p>
      In practice, it’s often enough to implement only
      <code>obj.toString()</code> as a “catch-all” method for all conversions
      that return a “human-readable” representation of an object, for logging or
      debugging purposes.
    </p>
  </body>
</html>
